package com.ruoyi.common.pay.syb.service;

import com.alibaba.fastjson2.JSON;
import com.ruoyi.common.exception.ServiceException;
import com.ruoyi.common.pay.wx.domain.Payable;
import com.ruoyi.common.utils.StringUtils;
import com.wechat.pay.java.service.payments.jsapi.model.PrepayWithRequestPaymentResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Map;

/**
 * @author wjh
 * 2024/9/9
 */
@Service
public class SybPayService {

    @Autowired
    private SybPayClient sybPayClient;

    /**
     * 微信小程序预下单
     */
    public PrepayWithRequestPaymentResponse prepayWxApp(Payable payable) {
        try {
            Map<String, String> result = sybPayClient.pay(
                    payable.payableMoney().longValue(),
                    payable.payableOutTradeNo(),
                    "W06",
                    payable.payableDescription(),
                    payable.payableDescription(),
                    payable.payableOpenId(),
                    "",
                    "",
                    "",
                    "",
                    "",
                    "",
                    "",
                    "",
                    "",
                    "",
                    "",
                    "",
                    "",
                    ""
            );

            if (result != null) {
                String payInfo = result.get("payinfo");
                if (StringUtils.hasText(payInfo)) {
                    return JSON.parseObject(payInfo, PrepayWithRequestPaymentResponse.class);
                }
            }

            return null;
        } catch(Exception e) {
            throw new ServiceException("调起支付失败：" + e.getMessage());
        }
    }

}
